---
title: "FreeBSD 7.4-RELEASE Release Notes"
sidenav: download
---

++++


<h3 class="CORPAUTHOR">The FreeBSD Project</h3>

<p class="COPYRIGHT">Copyright &copy; 2011 The FreeBSD Documentation Project</p>

<p class="PUBDATE">$FreeBSD: stable/7/release/doc/en_US.ISO8859-1/relnotes/article.sgml
219008 2011-02-24 19:22:59Z hrs $<br />
</p>

<div class="LEGALNOTICE"><a id="TRADEMARKS" name="TRADEMARKS"></a>
<p>FreeBSD is a registered trademark of the FreeBSD Foundation.</p>

<p>IBM, AIX, EtherJet, Netfinity, OS/2, PowerPC, PS/2, S/390, and ThinkPad are trademarks
of International Business Machines Corporation in the United States, other countries, or
both.</p>

<p>IEEE, POSIX, and 802 are registered trademarks of Institute of Electrical and
Electronics Engineers, Inc. in the United States.</p>

<p>Intel, Celeron, EtherExpress, i386, i486, Itanium, Pentium, and Xeon are trademarks or
registered trademarks of Intel Corporation or its subsidiaries in the United States and
other countries.</p>

<p>SPARC, SPARC64, SPARCengine, and UltraSPARC are trademarks of SPARC International, Inc
in the United States and other countries. SPARC International, Inc owns all of the SPARC
trademarks and under licensing agreements allows the proper use of these trademarks by
its members.</p>

<p>Many of the designations used by manufacturers and sellers to distinguish their
products are claimed as trademarks. Where those designations appear in this document, and
the FreeBSD Project was aware of the trademark claim, the designations have been followed
by the &#8220;&trade;&#8221; or the &#8220;&reg;&#8221; symbol.</p>
</div>

<div>
<div class="ABSTRACT"><a id="AEN18" name="AEN18"></a>
<p>The release notes for FreeBSD 7.4-RELEASE contain a summary of the changes made to the
FreeBSD base system on the 7.4-STABLE development line. This document lists applicable
security advisories that were issued since the last release, as well as significant
changes to the FreeBSD kernel and userland. Some brief remarks on upgrading are also
presented.</p>
</div>
</div>

<hr />
</div>

<div class="TOC">
<dl>
<dt><b>Table of Contents</b></dt>

<dt>1 <a href="#INTRO">Introduction</a></dt>

<dt>2 <a href="#NEW">What's New</a></dt>

<dd>
<dl>
<dt>2.1 <a href="#SECURITY">Security Advisories</a></dt>

<dt>2.2 <a href="#KERNEL">Kernel Changes</a></dt>

<dd>
<dl>
<dt>2.2.1 <a href="#PROC">Hardware Support</a></dt>

<dt>2.2.2 <a href="#NET-PROTO">Network Protocols</a></dt>

<dt>2.2.3 <a href="#DISKS">Disks and Storage</a></dt>

<dt>2.2.4 <a href="#FS">File Systems</a></dt>
</dl>
</dd>

<dt>2.3 <a href="#USERLAND">Userland Changes</a></dt>

<dd>
<dl>
<dt>2.3.1 <a href="#RC-SCRIPTS"><tt class="FILENAME">/etc/rc.d</tt> Scripts</a></dt>
</dl>
</dd>

<dt>2.4 <a href="#CONTRIB">Contributed Software</a></dt>

<dt>2.5 <a href="#RELENG">Release Engineering and Integration</a></dt>
</dl>
</dd>

<dt>3 <a href="#UPGRADE">Upgrading from previous releases of FreeBSD</a></dt>
</dl>
</div>

<div class="SECT1">
<h2 class="SECT1"><a id="INTRO" name="INTRO">1 Introduction</a></h2>

<p>This document contains the release notes for FreeBSD 7.4-RELEASE. It describes
recently added, changed, or deleted features of FreeBSD. It also provides some notes on
upgrading from previous versions of FreeBSD.</p>

<p>This distribution of FreeBSD 7.4-RELEASE is a release distribution. It can be found at
<a href="ftp://ftp.FreeBSD.org/" target="_top">ftp://ftp.FreeBSD.org/</a> or any of its
mirrors. More information on obtaining this (or other) release distributions of FreeBSD
can be found in the <a href="../../../../doc/en_US.ISO8859-1/books/handbook/mirrors.html"
target="_top">&#8220;Obtaining FreeBSD&#8221; appendix</a> to the <a
href="../../../../doc/en_US.ISO8859-1/books/handbook/" target="_top">FreeBSD
Handbook</a>.</p>

<p>All users are encouraged to consult the release errata before installing FreeBSD. The
errata document is updated with &#8220;late-breaking&#8221; information discovered late
in the release cycle or after the release. Typically, it contains information on known
bugs, security advisories, and corrections to documentation. An up-to-date copy of the
errata for FreeBSD 7.4-RELEASE can be found on the FreeBSD Web site.</p>
</div>

<div class="SECT1">
<hr />
<h2 class="SECT1"><a id="NEW" name="NEW">2 What's New</a></h2>

<p>This section describes the most user-visible new or changed features in FreeBSD since
7.3-RELEASE.</p>

<p>Typical release note items document recent security advisories issued after
7.3-RELEASE, new drivers or hardware support, new commands or options, major bug fixes,
or contributed software upgrades. They may also list changes to major ports/packages or
release engineering practices. Clearly the release notes cannot list every single change
made to FreeBSD between releases; this document focuses primarily on security advisories,
user-visible changes, and major architectural improvements.</p>

<div class="SECT2">
<hr />
<h3 class="SECT2"><a id="SECURITY" name="SECURITY">2.1 Security Advisories</a></h3>

<p>Problems described in the following security advisories have been fixed. For more
information, consult the individual advisories available from <a
href="http://security.FreeBSD.org/" target="_top">http://security.FreeBSD.org/</a>.</p>

<div class="INFORMALTABLE"><a id="AEN38" name="AEN38"></a>
<table border="0" frame="void" width="100%" class="CALSTABLE">
<col width="20%" />
<col width="20%" />
<col width="60%" />
<thead>
<tr>
<th>Advisory</th>
<th>Date</th>
<th>Topic</th>
</tr>
</thead>

<tbody>
<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-10:08.bzip2.asc"
target="_top">SA-10:08.bzip2</a></td>
<td>20&nbsp;September&nbsp;2010</td>
<td>
<p>Integer overflow in bzip2 decompression</p>
</td>
</tr>

<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-10:09.pseudofs.asc"
target="_top">SA-10:09.pseudofs</a></td>
<td>10&nbsp;October&nbsp;2010</td>
<td>
<p>Spurious mutex unlock</p>
</td>
</tr>

<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-10:10.openssl.asc"
target="_top">SA-10:10.openssl</a></td>
<td>29&nbsp;November&nbsp;2010</td>
<td>
<p>OpenSSL multiple vulnerabilities</p>
</td>
</tr>
</tbody>
</table>
</div>
</div>

<div class="SECT2">
<hr />
<h3 class="SECT2"><a id="KERNEL" name="KERNEL">2.2 Kernel Changes</a></h3>

<p>[sparc64] FreeBSD/sparc64 now supports reservation-based physical memory allocation
which provides better performance.</p>

<p>[sparc64] FreeBSD/sparc64 now supports UltraSPARC IV, IV+, and SPARC64 V CPUs.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=alq&amp;sektion=9&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">alq</span>(9)</span></a> support
has been improved. The <code class="FUNCTION">alq_writen()</code> and <code
class="FUNCTION">alq_getn()</code> KPIs have been extended to support variable length
messages, which is enabled at ALQ creation time depending on the arguments passed to
<code class="FUNCTION">alq_open()</code>. Also, the <tt
class="LITERAL">ALQ_NOACTIVATE</tt> and <tt class="LITERAL">ALQ_ORDERED</tt> flags have
been added to allow ALQ consumers to have more control over I/O scheduling and resource
acquisition respectively. These extensions are fully backward compatible.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=alq&amp;sektion=9&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">alq</span>(9)</span></a> support
is now provided as a kernel module <tt class="FILENAME">alq.ko</tt>.</p>

<p>The FreeBSD <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=memguard&amp;sektion=9&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">memguard</span>(9)</span></a>
framework has been improved to make it able to detect use-after-free of allocated
memories over a longer time. For more details, see <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=memguard&amp;sektion=9&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">memguard</span>(9)</span></a>
manual page.</p>

<p>The following <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sysctl&amp;sektion=8&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sysctl</span>(8)</span></a>
variables have been added: <code class="VARNAME">vm.kmem_map_size</code> for the current
kmem map size and <code class="VARNAME">vm.kmem_map_free</code> for largest contiguous
free range in kmem map.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&amp;revision=213554"
target="_top">r213554</a>, <a
href="http://svn.freebsd.org/viewvc/base?view=revision&amp;revision=213556"
target="_top">r213556</a>, <a
href="http://svn.freebsd.org/viewvc/base?view=revision&amp;revision=213560"
target="_top">r213560</a>]</p>

<div class="SECT3">
<hr />
<h4 class="SECT3"><a id="PROC" name="PROC">2.2.1 Hardware Support</a></h4>

<p>[amd64, i386] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ichwd&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ichwd</span>(4)</span></a> driver
now supports Intel NM10 Express chipset watchdog timer.</p>

<p>[amd64, i386] The qpi(4) pseudo bus driver has been added. This supports extra PCI
buses on Intel QPI chipsets where various hardware such as memory controllers for each
socket is connected.</p>

<div class="SECT4">
<hr />
<h5 class="SECT4"><a id="MM" name="MM">2.2.1.1 Multimedia Support</a></h5>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=acpi_video&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">acpi_video</span>(4)</span></a>
driver has been updated. LCD brightness control notify handler has been implemented.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=acpi_sony&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">acpi_sony</span>(4)</span></a>
helper driver now supports default display brightness, wired LAN power, and bass
gain.</p>
</div>

<div class="SECT4">
<hr />
<h5 class="SECT4"><a id="NET-IF" name="NET-IF">2.2.1.2 Network Interface Support</a></h5>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=alc&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">alc</span>(4)</span></a> driver
now supports Atheros AR8151/AR8152 PCIe Gigabit/Fast Ethernet controllers.</p>

<p>The TX interrupt moderation timer in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=alc&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">alc</span>(4)</span></a> driver
has been reduced from 50ms to 1ms. The 50ms timer resulted in a poor UDP performance.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=bge&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">bge</span>(4)</span></a> driver
now supports BCM5718 x2 PCI Express dual-port gigabit Ethernet controller family. This
family is the successor to the BCM5714/BCM5715 family and supports IPv4/IPv6 checksum
offloading, TSO, VLAN hardware tagging, jumbo frames, MSI/MSIX, IOV, RSS and TSS. The
current version of the driver supports all hardware features except IOV and RSS/TSS.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=bge&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">bge</span>(4)</span></a> driver
now supports hardware MAC statistics in controller's internal memory for BCM5705 or newer
Broadcom controllers. These counters can be accessed via <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sysctl&amp;sektion=8&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sysctl</span>(8)</span></a>
variable <code class="VARNAME">dev.bge.<tt
class="REPLACEABLE"><i>N</i></tt>.stats.*</code> and provide useful information to
diagnose driver issues.</p>

<p>A long-standing bug of ASF heartbeat sending in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=bge&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">bge</span>(4)</span></a> driver
has been fixed.</p>

<p>UDP checksum offloading in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=bge&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">bge</span>(4)</span></a> driver
has been disabled by default. This is because Broadcom controllers have a bug which can
generate UDP datagrams with checksum value <tt class="LITERAL">0</tt> when TX UDP
checksum offloading is enabled. The checksum offloading can be enabled by using the
following loader tunable:</p>

<pre class="PROGRAMLISTING">
dev.bge.<tt class="REPLACEABLE"><i>N</i></tt>.forced_udpcsum
</pre>

<p>A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=bge&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">bge</span>(4)</span></a> driver
which prevented TSO from working in BCM57780 has been fixed.</p>

<p>A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=bge&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">bge</span>(4)</span></a> driver
that could lead to poor performance on a system with more than 4 GB RAM has been fixed.
The cause was that all of Broadcom controllers except the BCM5755 and later have a bug in
4 GB-boundary DMA processing and used the bounce buffer in an inefficient way.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cxgb&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">cxgb</span>(4)</span></a> driver
now supports hardware filtering based on inspection of L2/L3/L4 headers. Filtering based
on source IP address, destination IP address, source port number, destination port
number, 802.1q VLAN frame tag, UDP, TCP, and MAC address is possible. The configuration
can be done by the cxgbtool(8) utility. Note that cxgbtool(8) is in <tt
class="FILENAME">src/usr.sbin/cxgbtool</tt> but not compiled by default.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=em&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">em</span>(4)</span></a> driver has
been updated to version 7.1.9.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=em&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">em</span>(4)</span></a> and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=igb&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">igb</span>(4)</span></a> drivers
now provide statistics counters as <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sysctl&amp;sektion=8&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sysctl</span>(8)</span></a> MIB
objects.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fxp&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">fxp</span>(4)</span></a> driver
now exports the hardware MAC statistics via <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sysctl&amp;sektion=8&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sysctl</span>(8)</span></a>
variables.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fxp&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">fxp</span>(4)</span></a> driver
now supports TSO over VLAN on i82550 and i82551 controllers.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=igb&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">igb</span>(4)</span></a> driver
has been updated to version 2.0.7.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=miibus&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">miibus</span>(4)</span></a> has
been rewritten for the generic IEEE 802.3 annex 31B full duplex flow control support. The
<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=alc&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">alc</span>(4)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=bge&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">bge</span>(4)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=bce&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">bce</span>(4)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cas&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">cas</span>(4)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fxp&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">fxp</span>(4)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=gem&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">gem</span>(4)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=jme&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">jme</span>(4)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=msk&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">msk</span>(4)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=nfe&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">nfe</span>(4)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=re&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">re</span>(4)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=stge&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">stge</span>(4)</span></a>, and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=xl&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">xl</span>(4)</span></a> drivers
along with atphy(4), bmtphy(4), brgphy(4), e1000phy(4), gentbi(4), inphy(4),
ip1000phy(4), jmphy(4), nsgphy(4), nsphyter(4), and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rgephy&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">rgephy</span>(4)</span></a> have
been updated to support flow control via this facility.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=msk&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">msk</span>(4)</span></a> driver
has been improved:</p>

<ul>
<li>
<p>It now supports 88E8059 (Marvell Yukon Optima) devices.</p>
</li>

<li>
<p>A rudimentary interrupt moderation with programmable countdown timer register has been
implemented. The default parameter of the holdoff time is 100us and this can be changed
via sysctl variable <code class="VARNAME">dev.mskc.<tt
class="REPLACEABLE"><i>0</i></tt>.int_holdoff</code>. Note that the interrupt moderation
is shared resource on a dual-port controllers and it is impossible to use separate
interrupt moderation values for each port.</p>
</li>
</ul>

<p>A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mxge&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mxge</span>(4)</span></a> driver
that prevented TSO from working has been fixed.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=nfe&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">nfe</span>(4)</span></a> driver
now supports WoL (Wake on LAN).</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=re&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">re</span>(4)</span></a> driver now
uses <tt class="LITERAL">2048</tt> as PCIe Maximum Read Request Size. This improves bulk
transfer performance.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=re&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">re</span>(4)</span></a> driver now
supports 64-bit DMA addressing for RTL810xE/RTL8168/RTL8111 PCIe controllers.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=re&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">re</span>(4)</span></a> driver now
supports hardware interrupt moderation of TX completion interrupts on RTL8169/RTL8168
controllers.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rl&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">rl</span>(4)</span></a> driver now
supports WoL (Wake on LAN) on RTL8139B or newer controllers.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rl&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">rl</span>(4)</span></a> driver now
supports a device hint to change a way of register access. Although some newer RTL8139
controllers support memory-mapped register access, it is difficult to detect the support
automatically. For this reason the driver uses I/O mapping by default and provides the
following device hint. If it is set to <tt class="LITERAL">0</tt>, the driver uses memory
mapping for register access.</p>

<pre class="PROGRAMLISTING">
hint.rl.<tt class="REPLACEABLE"><i>N</i></tt>.prefer_iomap="0"
</pre>

<p>Note that the default value is <tt class="LITERAL">1</tt>.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rl&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">rl</span>(4)</span></a> driver has
improved interrupt handling. It now has better TX performance under high RX load.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sk&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sk</span>(4)</span></a> driver now
disables TX checksum offloading by default. This is because some revisions of the Yukon
controller generate corrupted frames. The checksum offloading can be enabled manually by
using <code class="OPTION">txcsum</code> option in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ifconfig&amp;sektion=8&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ifconfig</span>(8)</span></a>
utility.</p>

<p>A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sk&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sk</span>(4)</span></a> driver has
been fixed. It did not program the station address for Yukon controllers and overriding
the station address with <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ifconfig&amp;sektion=8&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ifconfig</span>(8)</span></a> was
not possible.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sge&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sge</span>(4)</span></a> driver
for Silicon Integrated Systems SiS190/191 Fast/Gigabit Ethernet has been added. This
supports TSO and TSO over VLAN.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sis&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sis</span>(4)</span></a> driver
now supports WoL (Wake on LAN) on NS DP8315 controller.</p>

<p>A tunable <code class="VARNAME">dev.sis.<tt
class="REPLACEABLE"><i>N</i></tt>.manual_pad</code> for the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sis&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sis</span>(4)</span></a> driver
has been added. This controls whether padding with 0x00 for short frames is done by CPU,
rather than the controller. The reason why this tunable has been added is that NS
DP83815/DP83816 pads them with 0xff though RFC 1042 specifies it should be 0x00. The
tunable is disabled by default, which means padding with 0xff is used because padding
with 0x00 by software needs extra CPU cycles. Enabling <code
class="VARNAME">manual_pad</code>, by setting this <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sysctl&amp;sektion=8&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sysctl</span>(8)</span></a>
variable to a non-zero value, forces the use of software padding.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ste&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ste</span>(4)</span></a> driver
now supports a device hint to change the device register access mode. The driver uses
memory-mapped register access by default, but this caused stability problems with some
old IC Plus Corp (formerly Sundace) controllers. The following device hint makes the
driver use I/O mapping for register access:</p>

<pre class="PROGRAMLISTING">
hint.ste.<tt class="REPLACEABLE"><i>N</i></tt>.prefer_iomap="1"
</pre>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=xl&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">xl</span>(4)</span></a> driver now
supports WoL (Wake on LAN). Note that not all controllers support this functionality and
some need an additional remote wakeup cable.</p>
</div>
</div>

<div class="SECT3">
<hr />
<h4 class="SECT3"><a id="NET-PROTO" name="NET-PROTO">2.2.2 Network Protocols</a></h4>

<p>An issue in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=carp&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">carp</span>(4)</span></a> pseudo
interface and linkstate changes of the underlying interfaces has been fixed. This
happened when a <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=carp&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">carp</span>(4)</span></a>
interface was created before the underlying interface and its linkstate became <tt
class="LITERAL">UP</tt>.</p>

<p>A new loader tunable <code class="VARNAME">net.link.ifqmaxlen</code> has been added.
It specifies the default value of send interface queue length. The default value for this
parameter is <code class="VARNAME">50</code>.</p>

<p>The FreeBSD NFS subsystem now supports a timeout for the negative name cache entries
in the client. This avoids a bogus negative name cache entry from persisting forever when
another client creates an entry with the same name within the same NFS server time of day
clock tick. A system-wide <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sysctl&amp;sektion=8&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sysctl</span>(8)</span></a> sysctl
variable <code class="VARNAME">vfs.nfs.negative_name_timeout</code> can be used to adjust
the timeout. Setting this variable to <tt class="LITERAL">0</tt> disables negative name
caching.</p>

<p>A new <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=netgraph&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">netgraph</span>(4)</span></a> node
<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ng_patch&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ng_patch</span>(4)</span></a> has
been added. This performs data modification of packets passing through. Modifications are
restricted to a subset of C language operations on unsigned integers of 8, 16, 32 or
64-bit size.</p>

<p>The TCP initial window increase in RFC 3390 which can be controlled by a <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sysctl&amp;sektion=8&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sysctl</span>(8)</span></a>
variable <code class="VARNAME">net.inet.tcp.rfc3390</code> now reduces the congestion
window to the restart window if a TCP connection has been idle for one retransmit timeout
or more. For more details, see RFC 5681 Section 4.1.</p>

<p>A bug in FreeBSD TCP Path MTU discovery which could lead to a wrong calculation for an
MTU smaller than 256 octets has been fixed. Note that this bug did not affect MTUs equal
to or larger than 256 octets.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=siftr&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">siftr</span>(4)</span></a>,
Statistical Information For TCP Research (SIFTR) kernel module has been added. This is a
facility that logs a range of statistics on active TCP connections to a log file. It
provides the ability to make highly granular measurements of TCP connection state, aimed
at system administrators, developers and researchers.</p>

<p>The FreeBSD TCP reassembly implementation has been improved. A long-standing
accounting bug affecting SMP systems has been fixed and the <code
class="VARNAME">net.inet.tcp.reass.maxqlen</code> <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sysctl&amp;sektion=8&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sysctl</span>(8)</span></a>
variable has been retired in favor of a per-connection dynamic limit based on the receive
socket buffer size. FreeBSD receivers now handle packet loss (particularly losses caused
by queue overflows) significantly better than before which improves connection
throughput.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=tun&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">tun</span>(4)</span></a> pseudo
interface driver now supports explicit UP/DOWN linkstate.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=vlan&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">vlan</span>(4)</span></a> pseudo
interface now supports TSO (TCP Segmentation Offloading). The capability flag is named as
<code class="VARNAME">IFCAP_VLAN_HWTSO</code> and it is separated from <code
class="VARNAME">IFCAP_VLAN_HWTAGGING</code>. The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=age&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">age</span>(4)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=alc&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">alc</span>(4)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ale&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ale</span>(4)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=bce&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">bce</span>(4)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=bge&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">bge</span>(4)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cxgb&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">cxgb</span>(4)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=jme&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">jme</span>(4)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=re&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">re</span>(4)</span></a>, and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mxge&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mxge</span>(4)</span></a> driver
support this feature.</p>
</div>

<div class="SECT3">
<hr />
<h4 class="SECT3"><a id="DISKS" name="DISKS">2.2.3 Disks and Storage</a></h4>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=arcmsr&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">arcmsr</span>(4)</span></a> driver
has been updated to version 1.20.00.19.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ata&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ata</span>(4)</span></a> driver
now supports <tt class="LITERAL">spindown</tt> facility of ATA disks. The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=atacontrol&amp;sektion=8&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">atacontrol</span>(8)</span></a>
utility has a new subcommand <tt class="COMMAND">spindown</tt> to support this from
userland.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=gconcat&amp;sektion=8&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">gconcat</span>(8)</span></a> GEOM
class now supports kernel crash dump. The dumping is performed to the component where a
dump partition begins.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=gmultipath&amp;sektion=8&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">gmultipath</span>(8)</span></a>
utility now supports <tt class="COMMAND">destroy</tt>, <tt class="COMMAND">rotate</tt>,
<tt class="COMMAND">getactive</tt> commands.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ispfw&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ispfw</span>(4)</span></a>, the
firmware for <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=isp&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">isp</span>(4)</span></a> driver
has been added.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=twa&amp;sektion=4&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">twa</span>(4)</span></a> driver
has been updated. The version number is 3.70.05.010.</p>
</div>

<div class="SECT3">
<hr />
<h4 class="SECT3"><a id="FS" name="FS">2.2.4 File Systems</a></h4>

<p>The inode number handling in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ffs&amp;sektion=7&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ffs</span>(7)</span></a> file
system is now unsigned. Previously some large inode numbers can be treated as negative,
and this issue shows up at file systems with the size of more than 16Tb in 16k block
case. The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=newfs&amp;sektion=8&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">newfs</span>(8)</span></a> utility
never create a file system with more than 2^32 inodes by cutting back on the number of
inodes per cylinder group if necessary to stay under the limit.</p>

<p>A possible deadlock of <tt class="COMMAND">zfs receive</tt> has been fixed.</p>
</div>
</div>

<div class="SECT2">
<hr />
<h3 class="SECT2"><a id="USERLAND" name="USERLAND">2.3 Userland Changes</a></h3>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=arp&amp;sektion=8&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">arp</span>(8)</span></a> utility
has been improved. It now runs faster even when a single interface has a number of
aliases.</p>

<p>A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=b64decode&amp;sektion=1&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">b64decode</span>(1)</span></a>
utility that prevented an <code class="OPTION">-r</code> option from handling arbitrary
breaks in a base64 encoded string has been fixed.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=chgrp&amp;sektion=1&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">chgrp</span>(1)</span></a> and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=chown&amp;sektion=8&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">chown</span>(8)</span></a> now
support a <code class="OPTION">-x</code> flag to make it not traverse across multiple
mount points for the recursive operation.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cp&amp;sektion=1&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">cp</span>(1)</span></a> now
supports a <code class="OPTION">-x</code> flag to make it not traverse across multiple
mount points for the recursive operation.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=dhclient&amp;sektion=8&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">dhclient</span>(8)</span></a>
utility now reports a reason for exiting and the 10-second period in which the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=dhclient&amp;sektion=8&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">dhclient</span>(8)</span></a>
ignores routing messages has been changed to start just after <tt
class="FILENAME">dhclient-script</tt> starts instead of just after it finished. This
change fixes a symptom that <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=dhclient&amp;sektion=8&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">dhclient</span>(8)</span></a>
silently exits under a certain condition.</p>

<p>A bug in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=find&amp;sektion=1&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">find</span>(1)</span></a> utility
has been fixed. An option <code class="OPTION">-newerXB</code> was interpreted as the
same as <code class="OPTION">-newerXm</code>.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=tftp&amp;sektion=1&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">tftp</span>(1)</span></a> and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=tftpd&amp;sektion=8&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">tftpd</span>(8)</span></a>
utilities have been improved for better interoperability and they now support RFC 1350,
2347, 2348, 2349, and 3617.</p>

<p>An accuracy issue in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=jn&amp;sektion=3&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">jn</span>(3)</span></a> and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=jnf&amp;sektion=3&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">jnf</span>(3)</span></a> functions
in <tt class="FILENAME">libm</tt> has been fixed.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=indent&amp;sektion=1&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">indent</span>(1)</span></a>
utility now supports a <code class="OPTION">-ta</code> flag to treat all <tt
class="LITERAL">_t</tt>-suffixed identifiers as types.</p>

<p>The <code class="OPTION">-p</code> option in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mount&amp;sektion=8&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mount</span>(8)</span></a> utility
now displays the <tt class="LITERAL">rw</tt> mount option correctly as in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fstab&amp;sektion=5&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">fstab</span>(5)</span></a>
format.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ncal&amp;sektion=1&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ncal</span>(1)</span></a> utility
has been updated. The option <code class="OPTION">-b</code> has been replaced with <code
class="OPTION">-C</code> and <code class="OPTION">-B <tt
class="REPLACEABLE"><i>number</i></tt></code>. Options <code class="OPTION">-3</code> to
show previous, current and next month, and <code class="OPTION">-A <tt
class="REPLACEABLE"><i>number</i></tt></code> to show months after current month have
been added. The option <code class="OPTION">-m <tt class="REPLACEABLE"><i>N</i></tt> <tt
class="REPLACEABLE"><i>YYYY</i></tt></code> now prints only the month, not the whole
year.</p>

<p>An issue in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=newfs&amp;sektion=8&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">newfs</span>(8)</span></a> utility
has been fixed. A UFS1 file system created with 64KB blocksize was incorrectly recognized
as one with a broken superblock. This is because the FreeBSD kernel checks a partition
first for a UFS2 superblock at 64KB offset while it is possible that a UFS1 file systems
with 64KB blocksize has an alternative superblock at the same location. For example, a
file system created by <tt class="COMMAND">newfs -U -O 1 -b 65536 -f 8192</tt> could lead
to this symptom.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=newsyslog&amp;sektion=8&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">newsyslog</span>(8)</span></a>
utility does not consider non-existence of a PID file as an error now. A new flag <code
class="OPTION">-P</code> reverts it to the old behavior.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=newsyslog&amp;sektion=8&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">newsyslog</span>(8)</span></a>
utility now supports an <code class="OPTION">-S <tt
class="REPLACEABLE"><i>pidfile</i></tt></code> option to override the default <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=syslogd&amp;sektion=8&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">syslogd</span>(8)</span></a> PID
file.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=pmcstat&amp;sektion=8&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">pmcstat</span>(8)</span></a>
utility now supports a file and a network socket as a top source. A new option <code
class="OPTION">-O <tt class="REPLACEABLE"><i>filename</i></tt></code> specifies to send
log output to <tt class="REPLACEABLE"><i>filename</i></tt>, and another new option <code
class="OPTION">-R <tt class="REPLACEABLE"><i>filename</i></tt></code> specifies to
receive events from <tt class="REPLACEABLE"><i>filename</i></tt>. For a socket, the <tt
class="REPLACEABLE"><i>filename</i></tt> is in a form of <tt
class="REPLACEABLE"><i>ipaddr:port</i></tt>. This allows top monitoring over TCP on a
system with no local symbols, for example.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=powerd&amp;sektion=8&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">powerd</span>(8)</span></a>
utility now supports an <code class="OPTION">-m <tt
class="REPLACEABLE"><i>freq</i></tt></code> and <code class="OPTION">-M <tt
class="REPLACEABLE"><i>freq</i></tt></code> to control the minimum and maximum frequency,
respectively.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ruptime&amp;sektion=1&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ruptime</span>(1)</span></a>
utility now displays hostnames longer than 12 characters.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=stat&amp;sektion=1&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">stat</span>(1)</span></a> utility
now supports <tt class="LITERAL">%Sf</tt> output specifier to display the file flags
symbolically.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sysctl&amp;sektion=8&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sysctl</span>(8)</span></a>
utility now supports a <code class="OPTION">-i</code> flag to ignore failures while
retrieving individual OIDs. This allows the same list of OIDs to be passed to <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sysctl&amp;sektion=8&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sysctl</span>(8)</span></a> across
different systems where particular OIDs may not exist, and still get as much information
as possible from them.</p>

<div class="SECT3">
<hr />
<h4 class="SECT3"><a id="RC-SCRIPTS" name="RC-SCRIPTS">2.3.1 <tt
class="FILENAME">/etc/rc.d</tt> Scripts</a></h4>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rc.conf&amp;sektion=5&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">rc.conf</span>(5)</span></a> now
supports a <code class="VARNAME">firewall_coscripts</code> variable. This should contain
a list of commands which should be executed after firewall starts or stops.</p>

<p>The <tt class="FILENAME">rc.d/tmp</tt> script now uses a unique directory name
prefixed with <tt class="FILENAME">/tmp/.diskless</tt> instead of <tt
class="FILENAME">/tmp/.diskless</tt> itself. This fixes an issue when <tt
class="FILENAME">/tmp/.diskless</tt> exists before the script runs.</p>
</div>
</div>

<div class="SECT2">
<hr />
<h3 class="SECT2"><a id="CONTRIB" name="CONTRIB">2.4 Contributed Software</a></h3>

<p><b class="APPLICATION">ISC BIND</b> has been updated to version 9.4-ESV-R4.</p>

<p>The GNU <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cpio&amp;sektion=1&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">cpio</span>(1)</span></a> program
has been updated to version 2.8.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=less&amp;sektion=1&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">less</span>(1)</span></a> program
has been updated to version v436.</p>

<p>The <b class="APPLICATION">netcat</b> program has been updated to version 4.8.</p>

<p><b class="APPLICATION">OpenSSL</b> has been updated to version 0.9.8q.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=tcsh&amp;sektion=1&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">tcsh</span>(1)</span></a> program
has been updated to version 6.17.00.</p>

<p>The timezone database has been updated to the <b class="APPLICATION">tzdata2010o</b>
release.</p>
</div>

<div class="SECT2">
<hr />
<h3 class="SECT2"><a id="RELENG" name="RELENG">2.5 Release Engineering and
Integration</a></h3>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sysinstall&amp;sektion=8&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sysinstall</span>(8)</span></a>
utility now uses the following numbers for default and minimum partition sizes: 1GB for
<tt class="FILENAME">/</tt>, 4GB for <tt class="FILENAME">/var</tt>, and 1GB for <tt
class="FILENAME">/tmp</tt>.</p>

<p>The supported version of the <b class="APPLICATION">GNOME</b> desktop environment (<a
href="http://www.FreeBSD.org/cgi/url.cgi?ports/x11/gnome2/pkg-descr"><tt
class="FILENAME">x11/gnome2</tt></a>) has been updated to 2.32.1.</p>

<p>The supported version of the <b class="APPLICATION">KDE</b> desktop environment (<a
href="http://www.FreeBSD.org/cgi/url.cgi?ports/x11/kde4/pkg-descr"><tt
class="FILENAME">x11/kde4</tt></a>) has been updated to 4.5.5.</p>
</div>
</div>

<div class="SECT1">
<hr />
<h2 class="SECT1"><a id="UPGRADE" name="UPGRADE">3 Upgrading from previous releases of
FreeBSD</a></h2>

<p>[amd64, i386] Beginning with FreeBSD 6.2-RELEASE, binary upgrades between RELEASE
versions (and snapshots of the various security branches) are supported using the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=freebsd-update&amp;sektion=8&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span
class="REFENTRYTITLE">freebsd-update</span>(8)</span></a> utility. The binary upgrade
procedure will update unmodified userland utilities, as well as unmodified GENERIC or SMP
kernels distributed as a part of an official FreeBSD release. The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=freebsd-update&amp;sektion=8&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span
class="REFENTRYTITLE">freebsd-update</span>(8)</span></a> utility requires that the host
being upgraded has Internet connectivity.</p>

<p>An older form of binary upgrade is supported through the <tt
class="COMMAND">Upgrade</tt> option from the main <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sysinstall&amp;sektion=8&amp;manpath=FreeBSD+7.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sysinstall</span>(8)</span></a>
menu on CDROM distribution media. This type of binary upgrade may be useful on non-i386,
non-amd64 machines or on systems with no Internet connectivity.</p>

<p>Source-based upgrades (those based on recompiling the FreeBSD base system from source
code) from previous versions are supported, according to the instructions in <tt
class="FILENAME">/usr/src/UPDATING</tt>.</p>

<div class="IMPORTANT">
<blockquote class="IMPORTANT">
<p><b>Important:</b> Upgrading FreeBSD should, of course, only be attempted after backing
up <span class="emphasis"><i class="EMPHASIS">all</i></span> data and configuration
files.</p>
</blockquote>
</div>
</div>
</div>

<hr />
<p align="center"><small>This file, and other release-related documents, can be
downloaded from <a href="ftp://ftp.FreeBSD.org/">ftp://ftp.FreeBSD.org/</a>.</small></p>

<p align="center"><small>For questions about FreeBSD, read the <a
href="http://www.FreeBSD.org/docs.html">documentation</a> before contacting &#60;<a
href="mailto:questions@FreeBSD.org">questions@FreeBSD.org</a>&#62;.</small></p>

<p align="center"><small>All users of FreeBSD 7.4-STABLE should subscribe to the &#60;<a
href="mailto:stable@FreeBSD.org">stable@FreeBSD.org</a>&#62; mailing list.</small></p>

<p align="center"><small>For questions about this documentation, e-mail &#60;<a
href="mailto:doc@FreeBSD.org">doc@FreeBSD.org</a>&#62;.</small></p>
++++


